\name{sim_from_model}
\Rdversion{1.1}
\alias{sim_from_model}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
%%  ~~function to do ... ~~
}
\description{
%%  ~~ A concise (1-5 lines) description of what the function does. ~~
}
\usage{
sim_from_model(hpriors, sim_pars, DEBUG = 1.1)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{hpriors}{
%%     ~~Describe \code{hpriors} here~~
}
  \item{sim_pars}{
%%     ~~Describe \code{sim_pars} here~~
}
  \item{DEBUG}{
%%     ~~Describe \code{DEBUG} here~~
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
%% ...
}
\references{
%% ~put references to the literature/web site here ~
}
\author{
%%  ~~who you are~~
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

## The function is currently defined as
function (hpriors, sim_pars, DEBUG = 1.1) 
{
    nocl = 2 * sim_pars$no_alleles - 1
    noco = sim_pars$noco
    index = 1:nocl
    if (sim_pars$maf == "from_model") {
        gnf_hp_shape1 = hpriors$gnfp$gnf_hp_shape1
        gnf_hp_shape2 = hpriors$gnfp$gnf_hp_shape2
        gnf_theta = hpriors$gnfp$gnf_theta
        gnf_apar = rbeta(1, shape1 = gnf_hp_shape1, shape2 = gnf_hp_shape2)
        gnf_ws = (choose((nocl - 1), 0:(nocl - 1)) * gnf_apar^index * 
            (1 - gnf_apar)^(nocl - index - 1))
        dparams = (gnf_theta * gnf_ws)
        if (sum(dparams < 1) > 0 & 0) {
            cat("Warning, some prior allele frequencies are extremely low, \nRaising frequency in minimum classes.\n")
        }
        dparams = pmax(dparams, rep(1, length(dparams)))
        gnf_lambda = rdirichlet(1, (dparams))
    }
    else {
        maf = sim_pars$maf
        if (nocl == 3) 
            m = maf
        else m = (maf^2)^(1/(nocl - 1))
        gnf_lambda = choose(nocl - 1, index - 1) * m^(nocl - 
            index) * (1 - m)^(index - 1)
        gnf_apar = "used_fixed_lambdas"
    }
    gnf_controls = make_control_freqs(objects = NULL, pop_freqs = gnf_lambda, 
        betas = sim_pars$betas)
    gnf_cases = make_case_freqs(objects = NULL, pop_freqs = gnf_lambda, 
        betas = sim_pars$betas)
    check = sum(abs(gnf_lambda) < 1e-08)
    if (0 & check > 0 & DEBUG > 0.9) {
        cat("Warning - have an extremely low prior on the allele frequency in", 
            check, "of the classes.\n")
        browser()
    }
    beta0 = sim_pars$betas[1]
    if (sim_pars$association) 
        beta1 = sim_pars$betas[2]
    else beta1 = 0
    cnv_types = sim_cnv_types(beta0, beta1, hpriors, sim_pars, 
        nocl = nocl, noco = noco, gnf_controls = gnf_controls, 
        gnf_cases = gnf_cases)
    if (DEBUG >= 2) {
        min_cnvt = range(cnv_types)[1]
        max_cnvt = range(cnv_types)[2]
        breaks = (min_cnvt - 0.5):(max_cnvt + 0.5)
        cat("Genotype Frequencies in controls and cases respectively:\n")
        cat(hist(cnv_types[[1]], plot = F, breaks = breaks)$counts, 
            "\n")
        cat(hist(cnv_types[[3]], plot = F, breaks = breaks)$counts, 
            "\n")
    }
    signal = sim_pars$signal/(sim_pars$difficulty/10)
    noise = sim_pars$noise * (sim_pars$difficulty/10)
    data_array = sim_intensities(cnv_types = cnv_types, intens_pars = sim_pars$intens_pars, 
        signal = signal, noise = noise, no_gtypes = nocl, no_probes = sim_pars$no_probes)
    if (sim_pars$difficulty >= 10) 
        data_array = complicate_intensities(data_array = data_array, 
            difficulty = sim_pars$difficulty, batch_effects = 2, 
            time_effects = 2)
    priors_used = list(beta0, beta1, gnf_apar, gnf_lambda)
    names(priors_used) = c("beta0", "beta1", "gnf_apar", "gnf_lambda")
    return_val = list(data_array, cnv_types, priors_used)
    names(return_val) = list("data_array", "cnv_types", "priors_used")
    return(return_val)
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
